#include "CRingBuffer.h"

CRingBuffer::CRingBuffer(void)
{
	//obt@TCYݒAobt@̊蓖ĂƏs
	buffersize = RINGBUFFER_SIZE_DEFAULT;

	buffer = new float[buffersize];
	memset(buffer, 0, sizeof(float) * buffersize);

	//ǂݍ݈ʒuƏ݈ʒuB
	read_pos = 0;
	write_pos = buffersize / 2;
	return ;
}

CRingBuffer::~CRingBuffer(void)
{
	//obt@J
	delete[] buffer;
}

void CRingBuffer::SetInterval(int interval)
{
	//intervalɕsȒl(傫A)ꍇ1ɂĂB
	interval = interval % buffersize;
	if (interval <= 0)
	{
		interval = 1;
	}

	//݈ʒuύXAobt@B
	write_pos = (read_pos + interval) % buffersize;
	memset(buffer, 0, sizeof(float) * buffersize);

	return ;
}

float CRingBuffer::GetValue()
{
	//ǂݍ݈ʒũf[^Ԃ
	return buffer[read_pos];
}


void CRingBuffer::SetValue(float value)
{
	//݈ʒuɃf[^
	buffer[write_pos] = value;
	return ;
}

void CRingBuffer::ForwardReadPosition()
{
	//ǂݍ݈ʒui߂
	read_pos = (read_pos + 1) % buffersize;
	return ;
}

void CRingBuffer::ForwardWritePosition()
{
	//݈ʒui߂
	write_pos = (write_pos + 1) % buffersize;
	return ;
}
